      function mpol2(h)
  
      implicit none
 
      integer, parameter :: rdgs=1
      integer :: h,i,k,k0,first=1
      real(16) :: mpol2,mtmp2
      complex(16) :: mat(rdgs)
      include 'colredm.f'
      save first,ix,jx,iclm,c2fd
 
      if (first == 1) then
       open(unit=30,file='colinds.dat',status='old',action='read')
       do k=1,iclr
        read(30,'(i10,i10)') ix(k),jx(k)
       end do
       close(30)
       open(unit=30,file='colfcts.dat',status='old',action='read')
       do k=1,iclrx
        read(30,'(i10,e20.12)') iclm(k),c2fd(k)
       end do
       close(30)
       first=0
      end if
 
      mat=(0.q0,0.q0)
 
      call mdkk1(mat,rdgs)
 
      mpol2=0.d0
      k0=1
 
      do i=1,iclrx
       mtmp2=0.d0
       do k=k0,k0+iclm(i)-1
        if (jx(k) == ix(k)) then
         mtmp2=mtmp2+conjg(mat(ix(k)))*mat(jx(k))
        else
         mtmp2=mtmp2+2.d0*conjg(mat(ix(k)))*mat(jx(k))
        end if
       end do
       mpol2=mpol2+c2fd(i)*mtmp2
       k0=k0+iclm(i)
      end do
  
      end function mpol2
